# -*- coding: utf-8 -*-

##########################################################################################
# @author Rodrigo Botafogo
#
# Copyright © 2018 Rodrigo Botafogo. All Rights Reserved. Permission to use, copy, modify, 
# and distribute this software and its documentation, without fee and without a signed 
# licensing agreement, is hereby granted, provided that the above copyright notice, this 
# paragraph and the following two paragraphs appear in all copies, modifications, and 
# distributions.
#
# IN NO EVENT SHALL RODRIGO BOTAFOGO BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, 
# INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF 
# THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF RODRIGO BOTAFOGO HAS BEEN ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#
# RODRIGO BOTAFOGO SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE 
# SOFTWARE AND ACCOMPANYING DOCUMENTATION, IF ANY, PROVIDED HEREUNDER IS PROVIDED "AS IS". 
# RODRIGO BOTAFOGO HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, 
# OR MODIFICATIONS.
##########################################################################################

module R

  module Scope

    def self.with(symbol, *args)
      attrs = []
      dataframe = args[0]
      
      args.each_with_index do |arg, index|
        arg.names.each { |n| attrs << n.to_sym }
      end

      Class.new do
        # create accessor functions for every variable name
        attrs.each do |name|
          define_method (name) do
            dataframe.method_missing(name)
          end
        end

        #----------------------------------------------------------------------------------------
        #
        #----------------------------------------------------------------------------------------
        
        define_method (:subset) do |*missing_args|
          R::Support.exec_function(R.subset_method, dataframe, *missing_args)
        end
        
        #----------------------------------------------------------------------------------------
        #
        #----------------------------------------------------------------------------------------

        define_method (:method_missing) do |missing_symbol, *missing_args|
          R::Support.process_missing(missing_symbol, false, dataframe, *missing_args)
        end
        
      end
      
    end
    
  end

  module Support

    def self.new_scope(symbol, *args, &block)
      executionScope = Scope.with(symbol, *args)
      scope = executionScope.new
      scope.instance_eval(&block)
      # scope
    end
    
  end

end
