# -*- encoding: utf-8 -*-
# stub: galaaz 0.5.0 ruby lib

Gem::Specification.new do |s|
  s.name = "galaaz".freeze
  s.version = "0.5.0"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.metadata = { "yard.run" => "yri" } if s.respond_to? :metadata=
  s.require_paths = ["lib".freeze]
  s.authors = ["Rodrigo Botafogo".freeze]
  s.date = "2020-06-06"
  s.description = "Galaaz brings the power of R to the Ruby community. Galaaz \nis based on TruffleRuby and FastR, GraalVM-based interpreters for Ruby and the R language \nfor statistical computing respectively.\n\nOver the past two decades, the R language for statistical computing has emerged as the de \nfacto standard for analysts, statisticians, and scientists. Today, a wide range of \nenterprises \u2013 from pharmaceuticals to insurance \u2013 depend on R for key business uses. FastR \nis a new implementation of the R language and environment for the Graal Virtual Machine.\n\nGalaaz tightly couples Ruby and R and allows the use of R inside a Ruby script. In a sense, \nGalaaz is similar to other solutions such as RinRuby, Rpy2, PipeR, and reticulate \n(https://blog.rstudio.com/2018/03/26/reticulate-r-interface-to-python/). However, since \nGalaaz couples TruffleRuby and FastR that both target the JVM there is no need to integrate \nboth solutions and there is no need to send data between Ruby and R, as it all resides in \nthe same VM. \n\nFurther, installation of Galaaz does not require the installation of GNU R. When installing\nGraalVM, just install TruffleRuby and FastR.\n".freeze
  s.email = "rodrigo.a.botafogo@gmail.com".freeze
  s.executables = ["galaaz".freeze, "gstudio".freeze, "gknit".freeze, "grun".freeze, "gknit-draft".freeze]
  s.files = ["bin/galaaz".freeze, "bin/gknit".freeze, "bin/gknit-draft".freeze, "bin/grun".freeze, "bin/gstudio".freeze]
  s.homepage = "http://github.com/rbotafogo/galaaz/wiki".freeze
  s.licenses = ["BSD-2-Clause".freeze]
  s.rubygems_version = "3.2.22".freeze
  s.summary = "Tightly coupling Ruby and R".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_development_dependency(%q<rspec>.freeze, ["~> 3.8"])
    s.add_development_dependency(%q<simplecov>.freeze, ["~> 0.16"])
    s.add_development_dependency(%q<rdoc>.freeze, ["~> 5.0"])
  else
    s.add_dependency(%q<rspec>.freeze, ["~> 3.8"])
    s.add_dependency(%q<simplecov>.freeze, ["~> 0.16"])
    s.add_dependency(%q<rdoc>.freeze, ["~> 5.0"])
  end
end
